<?php
/**
 * @copyright (c) Kufer Software GmbH, Oderstraße 7, D-84453 Mühldorf
 */

namespace Kufer\Web\KuferTools\Dozent\KursUebersicht\Detailsreiter\Termine;

use Kufer\Web\KuferTools\Dozent\KursUebersicht\Detailsreiter\Termine\TermineLoeschen\TermineLoeschenUseCase;

class DozTerminePresenter extends \Kufer\Web\KuferTools\Basis\Kursdetails\Detailsreiter\Termine\TerminePresenter
{
  protected function getView()
  {
    return new DozTermineReiterView($this->getViewModel());
  }

  protected function getViewModel()
  {
    $viewModel = parent::getViewModel();
    $allgSettings = \AllgSettingsAPI::getAllgSettings();
    $viewModel->kurs->status_erfolg = $this->getMessageStringSuccess($allgSettings);
    $viewModel->kurs->status_info = $this->getMessageStringInfo($allgSettings);
    $viewModel->kurs->status_fehler = $this->getMessageStringError($allgSettings);

    
    
    
    if (isset($this->useCaseResponse->nichtPassendeKursdaten) && count($this->useCaseResponse->nichtPassendeKursdaten) > 0
      && $this->useCaseResponse->hasRecht4KursAnpassen) {
      $viewModel->kurs->kursAnpassenDialog = $this->getKursAnpassenDialog();
    }

    $viewModel->jsdeclarations = '';
    
    if ($this->useCaseResponse->eintraegeGeloescht) {
      $viewModel->jsdeclarations = $this->getJSSelectedIds();
    }
    if ($this->useCaseResponse->termineLoeschenXsrf !== '') {
      $viewModel->jsdeclarations .= \JsOperations::getDeclarationString('KuferTools.TermineLoeschenXsrf', $this->useCaseResponse->termineLoeschenXsrf);
    }

    if ($this->useCaseResponse->showInformiereTnDialog) {
      $viewModel->kurs->informiereTnDialog = $this->getInformiereTnDialog();
    }

    return $viewModel;
  }

  
  private function getKursAnpassenDialog()
  {
    $viewModel = new \Kufer\Web\KuferTools\Basis\Termine\KursdatenAnpassenViewModel();
    $viewModel->nichtPassendeKursdaten = $this->useCaseResponse->nichtPassendeKursdaten;
    $viewModel->kurs = $this->useCaseResponse->kurs;
    $view = new KursdatenAnpassenView($viewModel);

    return $view->show();
  }

  
  private function getInformiereTnDialog()
  {
    $viewModel = new NachTerminAenderung\InformiereTnDialogViewModel();
    $viewModel->kurs = $this->useCaseResponse->kurs;
    $viewModel->action = $this->useCaseResponse->actionInformiereTnDialog;
    $viewModel->termineBearbeitet = $this->useCaseResponse->eintraegeGeaendert;
    $viewModel->termineGeloescht = $this->useCaseResponse->eintraegeGeloescht;
    $view = new NachTerminAenderung\InformiereTnDialogView($viewModel);

    return $view->show();
  }

  private function getMessageStringSuccess($pAllgSettings)
  {
    if ($this->useCaseResponse->statusCode == TermineLoeschenUseCase::SUCCESS_TERMINE_GELOESCHT) {
      return 'Die ausgewählten Termine wurden erfolgreich gelöscht.';
    }

    return '';
  }

  private function getMessageStringInfo($pAllgSettings)
  {
    

    return '';
  }

  private function getMessageStringError($pAllgSettings)
  {
    if ($this->useCaseResponse->statusCode == TermineLoeschenUseCase::ERROR_TERMINE_ANZAHL_NULL) {
      return 'Die ausgewählten Termine können nicht mehr gelöscht werden, weil sie nicht mehr existieren.';
    } elseif ($this->useCaseResponse->statusCode == TermineLoeschenUseCase::ERROR_TERMINE_UEBERTRAGUNG) {
      return $pAllgSettings->failSubmitMsgKursplanung;
    }

    return '';
  }

  protected function getJSSelectedIds(): string
  {
    $result = '';
    
    if (isset($this->useCaseResponse->selectedIds) && \StringOperations::strlen($this->useCaseResponse->selectedIds) > 0) {
      $selectedIdsAry = explode(':', $this->useCaseResponse->selectedIds);
      $result .= \JsOperations::getDeclarationJson('KuferTools.SelectedIds', $selectedIdsAry);
    } else {
      $result .= \JsOperations::getDeclarationJson('KuferTools.SelectedIds', array());
    }

    return $result;
  }
}